news/urls.py
from django.urls import path
from .views import index, search, NewsTopicList, NewsTopicCreate, NewsTopicUpdate, NewsTopicSelect, NewsTopicDelete, SearchBarCreate

urlpatterns = [
  path("index/<str:query_input>", index, name="index"),
  path("", NewsTopicList.as_view(), name="intro"),
  path("new/", NewsTopicCreate.as_view(), name="new"),
  path("edit/<int:pk>/", NewsTopicUpdate.as_view(),name="edit"),
  path("topics/", NewsTopicSelect.as_view(), name="topics"),
  path("delete/<int:pk>", NewsTopicDelete.as_view(), name="delete"),
  path("search/<str:search_bar>", search, name="search-detail"),
  path("search/", SearchBarCreate.as_view(), name="search")
]

news_project/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path("admin/", admin.site.urls),
    path("home/", include("news.urls") ),
    path("", include("news.urls")),
]

news/models.py
from django.db import models
# from django import forms

# Create your models here.
class NewsTopic(models.Model):
  topic_name = models.CharField(max_length=100)

  def __str__(self):
    return self.topic_name

class SearchBar(models.Model):
  search = models.CharField(max_length=100)

  def __str__(self):
    return self.search

news/views.py
from django.shortcuts import render
from django.urls import reverse_lazy
from newsapi import NewsApiClient
from django.views.generic.list import ListView
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from .models import NewsTopic, SearchBar
import environ

env = environ.Env()
environ.Env.read_env()

# Create your views here.
def index(request, query_input):

  KEY = env('API_KEY')

  newsapi = NewsApiClient(api_key=KEY)

  # if query_input in const.categories:
  topnews = newsapi.get_top_headlines(category=query_input)
  # topnews = newsapi.get_everything(qintitle=query_input)
  # print(topnews)
  # print(query_input)

  latest = topnews["articles"]
  news = []
  descr = []
  image = []
  link = []

  for i in range(3):
    # limited to 3 articles for simplicity with css work
    # for i in range(len(latest)): would include all articles
    info = latest[i]
    news.append(info["title"])
    descr.append(info["description"])
    image.append(info["urlToImage"])
    link.append(info["url"])
    # print("$$$$$$$", info)

  # print(latest[0])
  # prints the first item from the topnews articles list

  my_list = list(zip(news, descr, image, link))

    # if we remove list from this zip, we can iterate
    # through the 3 items we added above at a time
    # if we add list(), our list will have 3 items
    # so we can use index 0 to 2 in our html template

  context = {
    "my_list": my_list,
    "query_input": query_input,
  }

  return render(request, "index.html", context)

class NewsTopicList(ListView):
  model = NewsTopic
  template_name = "intro.html"

class NewsTopicSelect(ListView):
  model = NewsTopic
  template_name = "select.html"

class NewsTopicCreate(CreateView):
  model = NewsTopic
  template_name = "new.html"
  fields = ["topic_name"]

  def get_success_url(self):
    return reverse_lazy("intro")

class NewsTopicUpdate(UpdateView):
  model = NewsTopic
  template_name = "edit.html"
  fields = ["topic_name"]

  def get_success_url(self):
    return reverse_lazy("topics")

class NewsTopicDelete(DeleteView):
  model = NewsTopic
  template_name = "delete.html"

  def get_success_url(self):
    return reverse_lazy("topics")


# creating a view to search by name in title:
def search(request, search_bar):

  KEY = env('API_KEY')

  newsapi = NewsApiClient(api_key=KEY)
  everything = newsapi.get_everything(q=search_bar)

  latest = everything["articles"]
  news = []
  descr = []
  image = []
  link = []

  for i in range(3):
    info = latest[i]
    news.append(info["title"])
    descr.append(info["description"])
    image.append(info["urlToImage"])
    link.append(info["url"])

  # print(latest[0])

  my_list = list(zip(news, descr, image, link))

  context = {
    "my_list": my_list,
    "search_bar": search_bar,
  }

  return render(request, "search-detail.html", context)

class SearchBarCreate(CreateView):
  model = SearchBar
  template_name = "search.html"
  fields = ["search"]

  def get_success_url(self):
    return reverse_lazy("search-detail", args=[self.object] )

news/templates/base.html
{% load static %}

<!DOCTYPE html>
<html>
  <head>
    <link rel="stylesheet" href="{% static 'css/app.css' %}" />
    <title>News</title>
  </head>
  <body>
    <header>
      <nav>
        <a href="{% url 'intro' %}" class="link">Home</a>
        {% for topic in newstopic_list %}
        <a href="{% url 'index' topic.topic_name %}" class="link"
          >{{ topic.topic_name}}</a
        >
        {% endfor %}
        <a href="{% url 'topics' %}" class="link">edit topics</a>
        <a href="{% url "search" %}" class="link">search bar</a>
      </nav>
      <h1 class="header-title">Welcome to top {{ query_input }} {{search_bar }} news</h1>
    </header>
    {% block content %}{% endblock content %}
  </body>
</html>

news/templates/delete.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    <h2>Delete topic?</h2>
    <form method="post">
      {% csrf_token %} {{ form.as_p}}
      <button type="submit">Yes</button>
    </form>
  </div>
</main>
{% endblock content %}

news/templates/edit.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    <h2>Edit topic</h2>
    <form method="post">
      {% csrf_token %} {{ form.as_p}}
      <button type="submit">Submit</button>
    </form>
  </div>
</main>
{% endblock content %}

news/templates/index.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    {% for news in my_list %}
    <div class="news-card">
      <h2 class="title">
        <a href="{{ news.3 }}">{{ news.0 }}</a>
      </h2>
      <div class="description">{{news.1}}</div>
      <img class="image" src="{{news.2}}" alt="image" />
    </div>
    {% endfor %}
  </div>
</main>
{% endblock content %}

news/templates/intro.html
{% extends 'base.html' %} {% block content %}
<main>
  <div class="emojis">
    <div class="space">🪐🐒</div>
    <div class="food">🍨</div>
    <div class="travel">✈️</div>
    <div class="sports">🏀</div>
  </div>
</main>
{% endblock content %}

news/templates/new.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    <h2>New topic</h2>
    <form method="post">
      {% csrf_token %} {{ form.as_p}}
      <button type="submit">Create</button>
    </form>
  </div>
</main>
{% endblock content %}

news/templates/search-detail.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    {% for news in my_list %}
    <div class="news-card">
      <h2 class="title">
        <a href="{{ news.3 }}">{{ news.0 }}</a>
      </h2>
      <div class="description">{{news.1}}</div>
      <img class="image" src="{{news.2}}" alt="image" />
    </div>
    {% endfor %}
  </div>
</main>
{% endblock content %}

news/templates/search.html
{% extends 'base.html' %} {% block content %}
<main>
  <h2 class="search-bar">
    <form method="post">
      {% csrf_token %} {{form.as_p}}
      <button type="submit">Search</button>
    </form>
  </h2>
  <div class="emojis">
    <div class="space">🪐</div>
    <div class="food">🍨</div>
    <div class="travel">✈️</div>
    <div class="sports">🏀</div>
  </div>
</main>
{% endblock content %}

news/templates/select.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    <table>
      <thead>
        <tr>
          <th> <a href=" {% url "new" %}" class="link"> Add topic</a></th>
          <th></th>
          <th></th>
        </tr>
      </thead>
      <tbody>
        {% for topic in newstopic_list %}
        <tr>
          <td class="topic-title-table">{{ topic.topic_name}}</td>
          <td><a href="{% url 'edit' topic.pk %}" class="link">Edit</a></td>
          <td><a href="{% url 'delete' topic.pk %}" class="link">Delete</a></td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
</main>
{% endblock content %}